from cerberus.validator import Validator
from copy import deepcopy


class Check(object):
    @staticmethod
    def check_blank(item, columns):
        # 深拷贝后，函数内必须全用集合操作，否则出错
        _columns = deepcopy(set(columns))
        for i in set(columns):
            if item.get(i):
                _columns.remove(i)
        return list(set(_columns))
        # columns = set(columns)
        # sub = columns - set(item.keys())
        # item = pd.Series(item).replace(['', [], {}, None], np.NaN)
        # item_null = pd.isnull(item)
        # item = item[item_null]
        # item_blank = list(set(item.index) & sub)
        # return item_blank

    @staticmethod
    def check_schema(data, data_schema, rc, r_key, flag=None, allow_unknown=True, logger=None):
        """ 数据校验功能
        :param data: 待校验数据
        :param data_schema: 待校验数据应有格式
        :param rc: redis连接实例
        :param r_key: 日志数据存放的 redis key
        :param flag: 方便查询的日志标志位
        :param allow_unknown: 是否允许未知字段
        :param logger: log 实例
        :return:
        """

        v = Validator()
        v.allow_unknown = allow_unknown
        if v.validate(data, data_schema):
            return data
        else:
            data['error_process'] = '字段校验不通过'
            data['error_record'] = {'flag': flag, 'schema_error_load': v.errors, 'data_schema': data_schema}
            rc.json_push(r_key, data)
            if logger:
                logger.error('字段校验不通过', extra=data)
            return data
