from prometheus_client import Counter, Histogram, start_http_server

# ../spider-system/module/spider_tool/schedule.py
HTTP_COUNTER = Counter('the_number_of_http_or_https_requests',
                       'Counter: total http or https requests(include Exception)', ['status'])
METRICS_HTTP_SUCCESS_COUNTER = HTTP_COUNTER.labels("successful")
METRICS_HTTP_SUCCESS_200_COUNTER = HTTP_COUNTER.labels("200")
METRICS_HTTP_FAIL_COUNTER_DataFormatError = HTTP_COUNTER.labels("DataFormatError")
METRICS_HTTP_FAIL_COUNTER_NoResponseError = HTTP_COUNTER.labels("NoResponseError")
METRICS_HTTP_FAIL_COUNTER_MethodError = HTTP_COUNTER.labels("MethodError")
METRICS_HTTP_FAIL_COUNTER_JSRenderError = HTTP_COUNTER.labels("JSRenderError")
METRICS_HTTP_FAIL_COUNTER_SSLError = HTTP_COUNTER.labels("SSLError")
METRICS_HTTP_FAIL_COUNTER_ProxyError = HTTP_COUNTER.labels("ProxyError")
METRICS_HTTP_FAIL_COUNTER_ConnectTimeout = HTTP_COUNTER.labels("ConnectTimeout")
METRICS_HTTP_FAIL_COUNTER_ReadTimeout = HTTP_COUNTER.labels("ReadTimeout")
METRICS_HTTP_FAIL_COUNTER_ConnectionError = HTTP_COUNTER.labels("ConnectionError")
METRICS_HTTP_FAIL_COUNTER_ReadTimeoutError = HTTP_COUNTER.labels("ReadTimeoutError")
METRICS_HTTP_FAIL_COUNTER_MaxRetryError = HTTP_COUNTER.labels("MaxRetryError")
METRICS_HTTP_FAIL_COUNTER_NewConnectionError = HTTP_COUNTER.labels("NewConnectionError")
METRICS_HTTP_FAIL_COUNTER_ConnectTimeoutError = HTTP_COUNTER.labels("ConnectTimeoutError")
METRICS_HTTP_FAIL_COUNTER_ProtocolError = HTTP_COUNTER.labels("ProtocolError")
METRICS_HTTP_FAIL_COUNTER_ConnectionResetError = HTTP_COUNTER.labels("ConnectionResetError")
METRICS_HTTP_FAIL_COUNTER_UnknownError = HTTP_COUNTER.labels("UnknownError")

# ../spider-system/module/spider_tool/crawler.py
PROXY_COUNTER = Counter('counter_proxy', 'Counter: proxy')

RENDER_COUNTER = Counter('js_render', 'Counter: rendering javascript', ['status'])
METRICS_RENDER_SUCCESS_COUNTER = RENDER_COUNTER.labels("successful")
METRICS_RENDER_SUCCESS_200_COUNTER = RENDER_COUNTER.labels("200")
METRICS_RENDER_FAIL_COUNTER = RENDER_COUNTER.labels("failed")
RENDER_LATENCY = Histogram('render_latency_seconds', 'Render latency', ['render_type'])

# ../spider-tool/spider_tool/extractor.py
EXTRACT_COUNTER = Counter('counter_extractor', 'Counter: extract')

# add_list_redis.py
METRICS_INPUT = Counter('processing_input', 'Counter: processing input', ["input_type"])
METRICS_INPUT_LIST = METRICS_INPUT.labels("article_list")
METRICS_INPUT_WECHAT = METRICS_INPUT.labels("wechat")
METRICS_INPUT_COLLECT = METRICS_INPUT.labels("collect")
METRICS_INPUT_DATA = METRICS_INPUT.labels("data")

# add_wechat_redis.py
METRICS_OUTPUT = Counter('processing_output', 'Counter: processing output', ["output_type"])
METRICS_OUTPUT_LIST = METRICS_OUTPUT.labels("article_list")
METRICS_OUTPUT_WECHAT = METRICS_OUTPUT.labels("wechat")
METRICS_OUTPUT_COLLECT = METRICS_OUTPUT.labels("collect")
METRICS_OUTPUT_DATA = METRICS_OUTPUT.labels("data")

# # ../spider-system/module/spider_tool/crawler.py
# RENDER_COUNTER = Counter('js_render', 'Counter: rendering javascript', ['status'])
# METRICS_RENDER_SUCCESS_COUNTER = RENDER_COUNTER.labels("successful")
# METRICS_RENDER_FAIL_COUNTER = RENDER_COUNTER.labels("failed")
# RENDER_LATENCY = Histogram('render_latency_seconds', 'Render latency', ['render_type'])


# ../spider-system/module/spider_tool/extractor.py
# EXTRACT_COUNTER = Counter('counter_extractor', 'Counter: extract')

# api
METRICS_API = Counter('api_request', 'Counter: api', ["api_type"])
METRICS_API_COUNTER_CLASSIFY = METRICS_API.labels("classify_by_tag")
METRICS_API_COUNTER_SIMHASH = METRICS_API.labels("cal_simhash")
METRICS_API_COUNTER_PAIR = METRICS_API.labels("tag_pair_extract")
METRICS_API_COUNTER_ABSTRACTS = METRICS_API.labels("extract_abstracts")
METRICS_API_COUNTER_KEYWORD = METRICS_API.labels("get_kwd")

METRICS_API_SUCCESS_COUNTER_IMAGE = METRICS_API.labels("upload_img_successfully")
METRICS_API_FAIL_COUNTER_IMAGE = METRICS_API.labels("upload_img_unsuccessfully")

# push
PUSH_SUCCESS_COUNTER = Counter('pushing_module_successful', 'Counter: push to Business Side successfully',
                               ['push_type'])
METRICS_PUSH_SUCCESS_COUNTER_CMS = PUSH_SUCCESS_COUNTER.labels("cms")
METRICS_PUSH_SUCCESS_COUNTER_INSIGHT = PUSH_SUCCESS_COUNTER.labels("insight")
METRICS_PUSH_SUCCESS_COUNTER_JOBMD = PUSH_SUCCESS_COUNTER.labels("jobmd")

PUSH_FAIL_COUNTER = Counter('pushing_module_failed', 'Counter: push to Business Side unsuccessfully', ['push_type'])
METRICS_PUSH_FAIL_COUNTER_CMS = PUSH_FAIL_COUNTER.labels("cms")
METRICS_PUSH_FAIL_COUNTER_INSIGHT = PUSH_FAIL_COUNTER.labels("insight")
METRICS_PUSH_FAIL_COUNTER_JOBMD = PUSH_FAIL_COUNTER.labels("jobmd")
